<script lang="ts" setup>
import { onMounted, onActivated, onDeactivated, ref, onUnmounted } from 'vue';
import { useRoute, useRouter } from 'vue-router';
import { getRecord, hasRecord } from '../data/ProjectStore';
// @ts-ignore
import GlslCanvas from "glslCanvas"
console.clear()
const projectid = useRoute().params.id;

const project = getRecord(projectid as string);
if(typeof project === "undefined") {
    useRouter().push({name: "Landing"})
}

const onWindowResize = (ev: UIEvent) => {
    element.width = window.innerWidth;
    element.height = window.innerHeight;
}




const sandbox = ref<GlslCanvas>()
const glslCanvasWrapper = ref<HTMLDivElement>();
let element = document.createElement("canvas")
element.classList.add("canvasElement")
onMounted(() => {
    element.width = window.innerWidth;
    element.height = window.innerHeight;

    sandbox.value = new GlslCanvas(element);
    glslCanvasWrapper.value?.appendChild(element)
    //if (import.meta.env.DEV) {
    if (true) {
        const lines = project?.fragmentShader.split("\n");
        if(lines) {
            const countSize = (lines.length+"").length;
            const combined = lines.map( (e,i) => {
                let lineNumber = (i+1)+"";
                while(lineNumber.length < countSize) {
                    lineNumber = " "+lineNumber;
                }
                return lineNumber + " | " + e
            }).join("\n")
            console.info(combined)
        }

    } else {
        console.info(`See ${project?.gitCodeUrl} for source code.`)
    }
    sandbox.value.load(project!.fragmentShader)
    
    if (!!project?.uniforms) {
        for(const key of Object.keys(project.uniforms)) {
            sandbox.value.setUniform(key, project.uniforms[key]);
        }
    }
  
 
    window.addEventListener("resize", onWindowResize);

})




onUnmounted( () => {
    window.removeEventListener("resize", onWindowResize)
})

//@ts-ignore
window.project = project;
</script>

<template>

<div class="wrapper" ref="glslCanvasWrapper"/>
<QPageSticky position="bottom-right" :offset="[18,18]">
    <QBtn type="a" :href="project?.gitCodeUrl" target="_blank" padding="md" icon="code" round color="primary"><QTooltip class="bg-primary text-h5">Quellcode anschauen (neues Fenster)</QTooltip></QBtn>
</QPageSticky>

</template>

<style lang="scss" scoped>

.wrapper {
    line-height: 0;
}

</style>